diff --git a/libr/asm/p/asm_dalvik.c b/libr/asm/p/asm_dalvik.c
index f840d0a6d7bab..0b2d5d8a83678 100644
--- a/libr/asm/p/asm_dalvik.c
+++ b/libr/asm/p/asm_dalvik.c
@@ -199,8 +199,8 @@ static int dalvik_disassemble (RAsm *a, RAsmOp *op, const ut8 *buf, int len) {
 			break;
 		case fmtopvAApBBBBBBBB:
 			vA = (int) buf[1];
-			vB = (int) (buf[2] | (buf[3] << 8) | (buf[4] << 16) | (buf[5] << 24));
-			snprintf (str, sizeof (str), " v%i, 0x%08"PFMT64x, vA, a->pc + vB); // + (vB*2));
+			vB = (short) (buf[2] | (buf[3] << 8) | (buf[4] << 16) | (buf[5] << 24));
+			snprintf (str, sizeof (str), " v%i, 0x%08"PFMT64x, vA, a->pc + (vB * 2) - 6);
 			strasm = r_str_append (strasm, str);
 			break;
 		case fmtoptinlineI:
